"""
The names are generated by the random program, and the seeds are conceived randomly

Not all names are valid
https://www.business.qld.gov.au/industry/liquor-gaming/liquor/guidelines-listing/trading-names-licensed-premises
"""

from .tsv import TSV
from .utils import pickchance, pickone


class Company(TSV):
    def __init__(self, argv):
        if 'name' in argv:
            self.name = argv['name']
        if 'openingHours' in argv:
            self.openingHours = argv['openingHours']
        if 'isSixHourClosure' in argv:
            self.isSixHourClosure = argv['isSixHourClosure']

    def to_list(self):
        return [str(i) for i in [self.name, self.openingHours, self.isSixHourClosure]]

    def __str__(self):
        return '\n'.join(self.to_list())

    def name(self):
        return self.name

    def tsv(self):
        return '\t'.join(self.to_list())


def random_company_name():
    prefix = ['James Potter\'s', 'Grand Spark', 'Black Hill', 'Tea Park', 'Liberty', 'Mrs Chow\'s', 'Jonson\'s',
              'Oliver', 'Hassacci', 'Zhang\'s', 'Mr Corleone\'s', 'Captain Sock\'s', 'Bearman\'s', 'Brandulu']
    business = ['Little Kitchen', 'Restaurant', 'Pizza', 'Coffee', 'Hotel', 'Liquor Shop', 'Bar & Grill', 'Bar',
                'Noodle House']
    suffix = ['Ltd.', '', '']
    location = ['Sevenfield', 'Bluetown', 'Punch Hills', 'Cool Heights', 'Austin Bay', 'Adanmir Bay']

    p = pickone(prefix)
    b = pickone(business)
    s = pickone(suffix)
    l = pickone(location)

    # creates two styles, pick either one
    opts = [(' '.join([b, l])).strip(), (' '.join([p, b, s])).strip()]
    if pickchance(0.7):
        return opts[1]

    return opts[0]
